﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace adx_ol_cs_customToolbarCtl
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("D94FF2E2-7073-436C-8FAC-71438D82E5C8"), ProgId("adx_ol_cs_customToolbarCtl.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.ToolbarControls.ADXOutlookControlAdapter adxOutlookControlAdapter1;
        private ADXOlExplorerCommandBar adxOlExplorerCommandBar1;
        private ADXCommandBarAdvancedControl adxCommandBarAdvancedControl1;
        private UserControl1 userControl11;
        private ADXOutlookAppEvents adxOutlookEvents;
        private string defaultFolderName = "";
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOutlookControlAdapter1 = new AddinExpress.ToolbarControls.ADXOutlookControlAdapter(this.components);
            this.adxOlExplorerCommandBar1 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
            this.adxCommandBarAdvancedControl1 = new AddinExpress.MSO.ADXCommandBarAdvancedControl(this.components);
            this.userControl11 = new adx_ol_cs_customToolbarCtl.UserControl1();
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOlExplorerCommandBar1
            // 
            this.adxOlExplorerCommandBar1.CommandBarName = "CustomControlInCBarVS2005CS1";
            this.adxOlExplorerCommandBar1.CommandBarTag = "6aeea2af-cb0e-4c63-b38b-4413937364e5";
            this.adxOlExplorerCommandBar1.Controls.Add(this.adxCommandBarAdvancedControl1);
            this.adxOlExplorerCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarBottom;
            this.adxOlExplorerCommandBar1.Temporary = true;
            this.adxOlExplorerCommandBar1.UpdateCounter = 98;
            // 
            // adxCommandBarAdvancedControl1
            // 
            this.adxCommandBarAdvancedControl1.Control = this.userControl11;
            this.adxCommandBarAdvancedControl1.ControlTag = "3c2b6910-ef45-439b-a105-050c3bf34503";
            this.adxCommandBarAdvancedControl1.Temporary = true;
            this.adxCommandBarAdvancedControl1.UpdateCounter = 86;
            // 
            // userControl11
            // 
            this.userControl11.Location = new System.Drawing.Point(0, 0);
            this.userControl11.Name = "userControl11";
            this.userControl11.Size = new System.Drawing.Size(150, 76);
            this.userControl11.TabIndex = 0;
            // 
            // AddinModule
            // 
            this.AddinName = "adx_ol_cs_customToolbarCtl";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinInitialize);

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void adxOutlookEvents_ExplorerEvent(object sender, object explorer)
        {
            Outlook.MAPIFolder folder = null;
            Outlook.Selection selection = null;
            Outlook.MailItem mailItem = null;
            try
            {
                folder = (explorer as Outlook.Explorer).CurrentFolder;
                if (folder.Name == defaultFolderName)
                {
                    UserControl1 activeUserControl = (UserControl1)adxCommandBarAdvancedControl1.ActiveInstance;
                    if (activeUserControl != null)
                    {
                        string mailSize, userPropertiesCount, attachmentsCount, importance, sensitivity;
                        mailSize = userPropertiesCount = attachmentsCount = importance = sensitivity = "";
                        try
                        {
                            selection = (explorer as Outlook.Explorer).Selection;
                            if (selection.Count > 0)
                                mailItem = (selection[1] as Outlook.MailItem);

                            mailSize = mailItem.Size.ToString();
                            object obj = null;
                            try
                            {
                                obj = mailItem.UserProperties;
                                userPropertiesCount = ((Outlook.UserProperties)obj).Count.ToString();
                            }
                            finally
                            {
                                if (obj != null)
                                {
                                    Marshal.ReleaseComObject(obj);
                                    obj = null;
                                }
                            }
                            try
                            {
                                obj = mailItem.Attachments;
                                attachmentsCount = ((Outlook.Attachments)obj).Count.ToString();
                            }
                            finally
                            {
                                if (obj != null)
                                {
                                    Marshal.ReleaseComObject(obj);
                                    obj = null;
                                }
                            }
                            switch (mailItem.Importance)
                            {
                                case Outlook.OlImportance.olImportanceNormal:
                                    importance = "Normal";
                                    break;
                                case Outlook.OlImportance.olImportanceHigh:
                                    importance = "High";
                                    break;
                                case Outlook.OlImportance.olImportanceLow:
                                    importance = "Low";
                                    break;
                                default:
                                    importance = "Unknown";
                                    break;
                            }
                            switch (mailItem.Sensitivity)
                            {
                                case Outlook.OlSensitivity.olNormal:
                                    sensitivity = "Normal";
                                    break;
                                case Outlook.OlSensitivity.olConfidential:
                                    sensitivity = "Confidential";
                                    break;
                                case Outlook.OlSensitivity.olPersonal:
                                    sensitivity = "Personal";
                                    break;
                                case Outlook.OlSensitivity.olPrivate:
                                    sensitivity = "Private";
                                    break;
                                default:
                                    sensitivity = "Unknown";
                                    break;
                            }
                        }
                        catch { }
                        activeUserControl["MailSize"] = mailSize;
                        activeUserControl["UserPropertiesCount"] = userPropertiesCount;
                        activeUserControl["AttachmentsCount"] = attachmentsCount;
                        activeUserControl["Importance"] = importance;
                        activeUserControl["Sensitivity"] = sensitivity;
                    }
                }
            }
            finally
            {
                if (mailItem != null) Marshal.ReleaseComObject(mailItem);
                if (selection != null) Marshal.ReleaseComObject(selection);
                if (folder != null) Marshal.ReleaseComObject(folder);
            }
        }

        private void AddinModule_AddinInitialize(object sender, EventArgs e)
        {
            Outlook.NameSpace nameSpace = null;
            Outlook.MAPIFolder defaultFolder = null;
            try
            {
                nameSpace = this.OutlookApp.GetNamespace("MAPI");
                defaultFolder = nameSpace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderInbox);
                defaultFolderName = defaultFolder.Name;
                this.adxOlExplorerCommandBar1.FolderName = GetFolderPath(defaultFolder);
            }
            finally
            {
                if (defaultFolder != null)
                    Marshal.ReleaseComObject(defaultFolder);
                if (nameSpace != null)
                    Marshal.ReleaseComObject(nameSpace);
            }
        }

        private string GetFolderPath(Outlook.MAPIFolder folder)
        {
            string path = "";
            bool toBeReleased = false;
            object tempObj = null;
            try
            {
                while (folder != null)
                {
                    path = folder.Name + path;
                    try
                    {
                        tempObj = folder.Parent;
                    }
                    catch
                    {
                        tempObj = null;
                    }
                    if (!toBeReleased)
                        toBeReleased = true;// the caller will relese the folder passed
                    else
                        if (folder != null) { Marshal.ReleaseComObject(folder); folder = null; }
                    //The parent of a root folder is of the Outlook.Namespace type
                    folder = (tempObj as Outlook.MAPIFolder);
                    if (folder == null)
                        break;
                    else
                        path = "\\" + path;
                }
            }
            finally
            {
                if (tempObj != null) Marshal.ReleaseComObject(tempObj);
            }
            return path;
        }
    }
}

